=== debian/changelog ===
paraview (3.12.0-1) unstable; urgency=low

  * [ef4c675] Imported Upstream version 3.12.0
  * [57d464c] Remove stddef_ptrdiff.patch. Applied by upsteam
  * [c2db80a] Remove hange_std_parameter_for_compiler.patch. 
              Upsteam probably fixed that.
  * [8feea33] Fix FTBFS with boost 1.48
  * [373810b] Use boost 1.48 instead of default version.

 -- Anton Gladky <gladky.anton@gmail.com>  Thu, 22 Dec 2011 19:58:22 +0100

paraview (3.10.1-10) unstable; urgency=medium

  * [432acb9] Fix memory leak during animation export.
  * [7bb111a] Fix FTBFS due to strict-aliasing.

 -- Anton Gladky <gladky.anton@gmail.com>  Thu, 15 Dec 2011 18:49:41 +0100

paraview (3.10.1-9) unstable; urgency=high

  * [dac6a6f] Remove vtkEncodeString from paraview-dev. (Closes: #651369)
  * [94757b2] Remove vtkWrapHierarchy from paraview-python. (Closes: #651544)

 -- Anton Gladky <gladky.anton@gmail.com>  Fri, 09 Dec 2011 23:20:24 +0100

paraview (3.10.1-8) unstable; urgency=low

  * [9cc7b9e] Place python-modules into correct places via symlinks. 
              (Closes: #576837)
  * [42cd8ac] Hardening python-depends.

 -- Anton Gladky <gladky.anton@gmail.com>  Sun, 30 Oct 2011 14:25:05 +0100

paraview (3.10.1-7) unstable; urgency=low

  [ Mathieu Malaterre ]
  * [465d4bc] Remove XB-Python-Version line, as per dh_python2 policy. 
              (Closes: #643982)
  * [35324f0] Remove CMake release flag.
  * [cbf5c3e] Rely on mpi compiler to detect mpi installation.
  * [60cc610] Make sure to compile with openmpi.
  
  [ Anton Gladky ]
  * [c9b74a2] Fix FTBFS "format not a string literal and no format arg".

 -- Anton Gladky <gladky.anton@gmail.com>  Sat, 08 Oct 2011 20:23:55 +0200
