=== debian/rules ===
#! /usr/bin/make -f
#export DH_VERBOSE=1

DESTDIR = $(CURDIR)/debian/tmp

%:
	dh $@ --with python2 --parallel

export LD_LIBRARY_PATH+=:$(CURDIR)/debian/paraview/usr/lib/paraview

# http://lists.alioth.debian.org/pipermail/debian-science-maintainers/2011-June/008157.html
# cmake will inspect those settings automatically:
export CFLAGS := -Wall $(shell dpkg-buildflags --get CFLAGS)
export CXXFLAGS := -Wall $(shell dpkg-buildflags --get CXXFLAGS)
export CPPFLAGS := $(shell dpkg-buildflags --get CPPFLAGS)
export LDFLAGS := $(shell dpkg-buildflags --get LDFLAGS)

# CMAKE_SKIP_RPATH=OFF is important otherwise documentation generation will fails with:
# vtkSMExtractDocumentation: error while loading shared libraries: libvtkPVServerManager.so:
# No rule to make target `Documentation/ParaViewWriters.html', needed by `Documentation/paraview.qhp'.  Stop.

# Explicit settings of MPI_* is required see
# http://www.vtk.org/Bug/view.php?id=12572
PYVER = $(shell pyversions -dv)
extra_flags += -Wno-dev \
	-DPARAVIEW_GENERATE_PROXY_DOCUMENTATION=ON \
	-DCMAKE_INSTALL_RPATH=/usr/lib/paraview \
	-DCMAKE_INSTALL_RPATH_USE_LINK_PATH=OFF  \
	-DCMAKE_SKIP_RPATH=OFF \
	-DBUILD_SHARED_LIBS=ON \
	-DVTK_USE_SYSTEM_FREETYPE=ON \
	-DVTK_USE_SYSTEM_JPEG=ON \
	-DVTK_USE_SYSTEM_PNG=ON \
	-DPARAVIEW_INSTALL_THIRD_PARTY_LIBRARIES=OFF \
	-DBUILD_TESTING=OFF \
	-DVTK_USE_MPEG2_ENCODER=OFF \
	-DVTK_USE_FFMPEG_ENCODER=ON \
	-DFFMPEG_INCLUDE_DIR=/usr/include/libavcodec \
	-DPV_INSTALL_LIB_DIR="lib/paraview" \
	-DPV_INSTALL_INCLUDE_DIR="include/paraview" \
	-DVTK_USE_SYSTEM_TIFF=ON \
	-DVTK_USE_SYSTEM_ZLIB=ON \
	-DBUILD_EXAMPLES=OFF \
	-DVTK_USE_GL2PS=ON \
	-DVTK_USE_BOOST=ON \
	-DVTK_USE_SYSTEM_LIBXML2=ON \
	-DVTK_USE_SYSTEM_EXPAT=ON \
	-DDOCUMENTATION_HTML_HELP=ON \
	-DPARAVIEW_INSTALL_DEVELOPMENT=ON \
	-DBUILD_DOCUMENTATION=ON \
	-DVTK_USE_MYSQL=ON \
	-DVTK_USE_POSTGRES=ON \
	-DVTK_USE_N_WAY_ARRAYS=ON \
	-DPARAVIEW_USE_MPI=ON \
	-DMPI_INCLUDE_PATH="/usr/include/mpi" \
	-DPARAVIEW_USE_SYSTEM_HDF5=ON \
	-DHDF5_ENABLE_PARALLEL=ON \
	-DVTK_USE_SYSTEM_HDF5=ON \
	-DPARAVIEW_ENABLE_PYTHON=ON \
	-DVTK_USE_OGGTHEORA_ENCODER=ON \
	-DVTK_USE_SYSTEM_OGGTHEORA=ON \
	-DPARAVIEW_BUILD_PLUGIN_AdiosReader:BOOL=ON \
	-DPARAVIEW_BUILD_PLUGIN_EyeDomeLighting:BOOL=ON \

override_dh_auto_configure:
	dh_auto_configure -- $(extra_flags)

override_dh_compress:
	dh_compress -X.qch

override_dh_auto_install:
	dh_auto_install
	chmod a+x $(DESTDIR)/usr/lib/paraview/testing/FindString.tcl

override_dh_install:
	dh_install --list-missing
